/* @(#)$Id: pg_lineext_imp.h,v 2.1 2014/05/03 17:33:37 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.1 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#if ANSI_C
struct pager_lineext_write;
#endif

typedef void plext_init_extension P_((struct pager_lineext *ext,
				      struct stringbuffer * stringbuffer));
typedef void plext_dest_extension P_((struct pager_lineext *ext,
				      struct stringbuffer * stringbuffer));

#define LINEEXT_TYPE_magic   0xEB13

struct lineext_type {
    unsigned short            magic;       /* LINEEXT_TYPE_magic */

    plext_init_extension  *    plext_init_it;
    plext_dest_extension  *    plext_dest_it;
};

#define PAGER_LINEEXT_magic  0xEB12

extern struct pager_lineext {
    unsigned short            magic;       /* PAGER_LINEEXT_magic */

    int                       refcount;
    
    struct lineext_type     * lineext_type;
    union {
	void                 * dummy;
	struct plext_in_file * file;
	struct plext_in_mem  * mem;
    } a;
    
    struct stringbuffer      * stringbuffer;

} * malloc_pager_lineext P_((struct lineext_type * lineext_type,
			     struct stringbuffer * stringbuffer));


/* ------------ */

extern void inc_stringbuffer_refcount P_((struct stringbuffer *buffer));


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
