/* $Id: elmtls.h,v 2.7 2014/05/25 15:31:35 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.7 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
 *                  (was hurtta+elm@posti.FMI.FI, hurtta+elm@ozone.FMI.FI)
 *       or Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#include <openssl/ssl.h>
#include <openssl/bio.h>
#include <openssl/err.h>
#include <openssl/rand.h>


#include "elmshared.h"


#ifdef REMOTE_MBX

extern struct stream_type TLS_STREAM;
extern struct SE_option_type tls_options;

#define TLS_starttls 1

struct SE_option_value {   /* TLS option values */
    enum { tls_none = -1, 
	   v_ssl = 0, v_tls = 1
    } v_starttls;
    int flags;
};

extern int tls_init P_((int *errors));
extern union stream_types create_TLS_stream P_((int tls));


#include "ss_imp.h"
#include "connection_imp.h"
#include "mboxlib.h"
#include "mbx_imp.h"

extern enum tls_connection_state { 
    tls_not_connected = 0,
	tls_connected = 1,
	tls_error     = 2,
	tls_closing   = 3,
	tls_closed    = 4
				 } ss_TLS_state P_((struct streamsched *ss,
						    int stack_idx));

extern enum tls_peer_verify {
    tls_not_verified = 0,
	tls_peer_verified = 1,
	tls_verify_failed = -1        /* Value also used with SS_verify */
	} ss_TLS_verify P_((struct streamsched *ss,
			    int stack_idx,
			    struct string **errormsg,
			    struct string **peer_name));

#endif

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
